"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = require("react");

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var useSubscription = function useSubscription(client, options, fnToCache) {
  var memoOptions = (0, _react.useMemo)(function () {
    // if (process.env.NODE_ENV==='development') {
    //   console.log('useMemo memoRestOptions')
    // }      
    var variables = options.variables,
        restOptions = _objectWithoutProperties(options, ["variables"]);

    return _objectSpread({
      variables: variables || {}
    }, restOptions);
  }, // eslint-disable-next-line
  (0, _utils.options2arr)(options));
  var observableQuery = (0, _react.useMemo)(function () {
    var _observable;

    try {
      _observable = client.subscribe(memoOptions);
    } catch (errWatch) {//error
    }

    return _observable;
  }, [client, memoOptions]);
  (0, _react.useEffect)(function () {
    if (!observableQuery) {
      return;
    }

    var s = observableQuery.subscribe(function (resultNext) {
      if (fnToCache) {
        fnToCache(resultNext.data);
      }
    }, function (err) {//dispatch({type:'error', payload : err})
    });
    return function () {
      return s.unsubscribe();
    };
  }, [observableQuery, fnToCache]);
};

var _default = useSubscription;
exports["default"] = _default;